The superio needs 0x87 sent twice to 0x2eh (or 0x4eh) to enable extended function (power-on strapping).  Although this is already done in superio.c, it's not being done when w83627thf_early_serial.c is executed.  As such, no console_init without it.

Signed-off-by: Roger Zauner <roger@eskimo.com>


Index: src/superio/winbond/w83627thf/w83627thf_early_serial.c
===================================================================
--- src/superio/winbond/w83627thf/w83627thf_early_serial.c	(revision 2643)
+++ src/superio/winbond/w83627thf/w83627thf_early_serial.c	(working copy)
@@ -2,10 +2,26 @@
 #include "w83627thf.h"
 
 
+static inline void pnp_enter_ext_func_mode(device_t dev)
+{
+        unsigned port = dev >> 8;
+        outb(0x87, port);
+        outb(0x87, port);
+}
+
+static void pnp_exit_ext_func_mode(device_t dev)
+{
+        unsigned port = dev >> 8;
+        outb(0xaa, port);
+}
+
 static void w83627thf_enable_serial(device_t dev, unsigned iobase)
 {
-	pnp_set_logical_device(dev);
-	pnp_set_enable(dev, 0);
-	pnp_set_iobase(dev, PNP_IDX_IO0, iobase);
-	pnp_set_enable(dev, 1);
+        pnp_enter_ext_func_mode(dev);
+        pnp_set_logical_device(dev);
+        pnp_set_enable(dev, 0);
+        pnp_set_iobase(dev, PNP_IDX_IO0, iobase);
+        pnp_set_enable(dev, 1);
+        pnp_exit_ext_func_mode(dev);
 }
+
